#!/usr/bin/perl -i
#
#             2- ,        ,        
#      


#      
# perl -d d:\UP_to_num_layers.pl d:\Etalon.gcode

#       Notepad++,    
# ->_,      :
# C:\Strawberry\perl\bin\perl.exe -d "$(FULL_CURRENT_PATH)" D:\Etalon.gcode
#            
#  ,      Perl  

#       
# DB<1>b num   num  ,     		152
# DB<2>c             
# DB<3>s	       

use strict;
use warnings;
use File::Basename;
use File::Copy;

my $dirname = dirname(__FILE__);	    #      
my $RESULTHANDLE ="$dirname/Threated_2.gcode"; 	#     
my $HANDLE1 ="$dirname/1.gcode";		#    1.gcode       
my $HANDLE2 ="$dirname/2.gcode";     	#    2.gcode       
										#            Perl

my $FilePosFirstLayer=0;				#   1 
my $String='';							#  
my $PrevXY='';							#         X, Y          
my $CurrentZ='';						#         Z               
										# ..        G_ ,         ,    
my $Extruder=";Extruder \n" . $PrevXY . " " . "\nM106 P1 S0 ; Turn OFF Cold Plasma Torch \nG92 E0 \nG1 E15.3 F2800.00  ; Unretract to 15,3mm \n"; 
										#            
my $Plasma=";Plasma \nG92 E0 \nG1 E-15 F2800.00  ; Retract to 15mm \nM106 P1 S255 ; Turn ON Cold Plasma Torch \n"; 
										#             
my $CharPos=0;							#     

my $TMPFilePos=0;						#     
my $File1Pos=0;							#     1.Gcode
my $File2Pos=0;							#     2.Gcode

#      [],      ,      1,  (),       0
my @Strings1=();					    #  ,    1 
my @Strings2=();					    #  ,    2 
my $Array1Size= 0;						#     @Strings1
my $Array2Size= 0;						#     @Strings2

my $Flag=0;
my $FlagZ=0;
my $EndFlag=0;

my $tmp;
my $CurrentZ='';


if (-e $RESULTHANDLE)
{
unlink($RESULTHANDLE);					#          ,   ,     - 
} 
system("echo>$RESULTHANDLE");			#         DOS
open (RESULTFILE, ">$RESULTHANDLE");	#   
seek(RESULTFILE,0,0);					#     
truncate(RESULTFILE, 0);				#    
close(RESULTFILE);						#  

open (FILE1, "< $HANDLE1") || die "\n FILE NOT EXIST \n \n";		#   1     
open (FILE2, "< $HANDLE2") || die "\n FILE NOT EXIST \n \n";		#   2     
print("Files opened \n");
print("1_2_Combine.pl \n");

$Flag=0;
while (<FILE2>) 
{ #       
	if(/G1 Z/)
		{
		$tmp=$_;
		$tmp=substr($tmp,0,1);
		if($tmp ne ";")
			{
			$FlagZ=1;
			}
		}

	if(/;LAYER_CHANGE/)
		{
		$Flag=1;						#       
		$String=";###\n"; # nil
		push(@Strings2, $String);		#        
		$Plasma=";Plasma \nG92 E0 \nG1 E-15 F2800.00  ; Retract to 15mm \n";
		push(@Strings2, $Plasma);		#         
		$Array2Size=$Array2Size+2;
		}
	else
		{
		if(($Flag==1) && ($EndFlag==0) && ($FlagZ==0))
			{
			$String=$_;
			push(@Strings2, $String);
			$Array2Size++;
			}
			
		if(($Flag==1) && ($EndFlag==0) && ($FlagZ==1))
			{
			$Plasma=$_;
			$Plasma=substr($Plasma,0,length($Plasma)-1);
			$Plasma="$Plasma \nM106 P1 S255 ; Turn ON Cold Plasma Torch \nG4 S2 ; Wait 2 seconds to guarantee ignite torch\n";
			#       ,    ,   
			#  2            
			push(@Strings2, $Plasma);
			$Array2Size++;
			$FlagZ=0;
			}
		}
	
	if($EndFlag==1)	#            2 
		{
		$tmp=$_;
		$tmp=substr($tmp,0,1);
		if($tmp eq ";")			#     ,      2
			{
			$EndFlag=2;	#      
			}
		else
			{
			$String=$_;
			push(@Strings2, $String);
			$Array2Size++;
			}
		}
		
	if(/;END gcode/)	#    G-,         .
		{
		$EndFlag=1;
		}	
}
$String=";###\n"; # nil
push(@Strings2, $String);		#        ,      
								#         while
$Array2Size++;
close(FILE2);					#  

print("\nFILE 2.GCODE DONE \n");
print("Array2Size= $Array2Size\n");
system("pause");


open (RESULTFILE, ">$RESULTHANDLE") || die "\n FILE NOT EXIST \n \n";	#   ,    
#      2-    
while($Array2Size > 0)
	{
	#print("\n1!!!\n");
	$String = @Strings2[0];
	$tmp = shift(@Strings2);			#       @Strings1,  
	$Array2Size--;
	syswrite(RESULTFILE, $String, length($String));		#       
	#print($String);
	#system("pause");
	}
close(RESULTFILE);

print("\nFILE RESULTFILE.GCODE DONE \n");
system("pause");