#!/usr/bin/perl -i
#
#             2- ,        ,        
#      


#      
# perl -d d:\UP_to_num_layers.pl d:\Etalon.gcode

#       Notepad++,    
# ->_,      :
# C:\Strawberry\perl\bin\perl.exe -d "$(FULL_CURRENT_PATH)" D:\Etalon.gcode
#            
#  ,      Perl  

#       
# DB<1>b num   num  ,     		152
# DB<2>c             
# DB<3>s	       

use strict;
use warnings;
use File::Basename;
use File::Copy;

my $dirname = dirname(__FILE__);	    #      
my $RESULTHANDLE ="$dirname/Threated_1.gcode"; 	#     
my $HANDLE1 ="$dirname/1.gcode";		#    1.gcode       
my $HANDLE2 ="$dirname/2.gcode";     	#    2.gcode       
										#            Perl

my $FilePosFirstLayer=0;				#   1 
my $String='';							#  
my $PrevXY='';							#         X, Y          
my $CurrentZ='';						#         Z               
										# ..        G_ ,         ,    
my $Extruder=";Extruder \n" . $PrevXY . " " . "\nM106 P1 S0 ; Turn OFF Cold Plasma Torch \nG92 E0 \nG1 E15.3 F2800.00  ; Unretract to 15,3mm \n"; 
										#            
my $Plasma=";Plasma \nG92 E0 \nG1 E-15 F2800.00  ; Retract to 15mm \nM106 P1 S255 ; Turn ON Cold Plasma Torch \n"; 
										#             
my $CharPos=0;							#     

my $TMPFilePos=0;						#     
my $File1Pos=0;							#     1.Gcode
my $File2Pos=0;							#     2.Gcode

#      [],      ,      1,  (),       0
my @Strings1=();					    #  ,    1 
my @Strings2=();					    #  ,    2 
my $Array1Size= 0;						#     @Strings1
my $Array2Size= 0;						#     @Strings2

my $Flag=0;
my $EndFlag=0;

my $tmp;


if (-e $RESULTHANDLE)
{
unlink($RESULTHANDLE);					#          ,   ,     - 
} 
system("echo>$RESULTHANDLE");			#         DOS
open (RESULTFILE, ">$RESULTHANDLE");	#   
seek(RESULTFILE,0,0);					#     
truncate(RESULTFILE, 0);				#    
close(RESULTFILE);						#  

open (FILE1, "< $HANDLE1") || die "\n FILE NOT EXIST \n \n";		#   1     
open (FILE2, "< $HANDLE2") || die "\n FILE NOT EXIST \n \n";		#   2     
print("Files opened \n");
print("1_2_Combine.pl \n");

$Flag=0;
while (<FILE1>) 
{ #       
	if(/G1 X/)
		{
		$PrevXY=$_ . " " ;
		$CharPos=index($PrevXY, 'E');
		$PrevXY=substr($PrevXY,0,$CharPos-1);	#    E
		}
		
	if(/G1 Z/)
		{
		$CurrentZ=$_;
		$CurrentZ=substr($CurrentZ,0,length($CurrentZ)-2);
		}
		
	if(/M77/)	#       1   
		{
		if($EndFlag==0)
			{
			$String=";###\n"; # nil
			push(@Strings1, $String);
			$Array1Size++;
			$EndFlag++;
			}
		}
		
	if(/;LAYER_CHANGE/)
		{
		if($Flag<2)
			{
			$String=$_;
			push(@Strings1, $String);
			$Array1Size++;
			$Flag++;
			}
		else
			{
			$String=";###\n"; # nil
			push(@Strings1, $String);
			
			$Extruder=";Extruder \n$CurrentZ \n$PrevXY \nM106 P1 S0 ; Turn OFF Cold Plasma Torch \nG92 E0 \nG1 E15.3 F2800.00  ; Unretract to 15,3mm \n"; 
			push(@Strings1, $Extruder);
			$String=$_;
			push(@Strings1, $String);
			$Array1Size=$Array1Size+3;
			}
		}
	else
		{
		if($EndFlag==0)
			{
			$String=$_;
			push(@Strings1, $String);
			$Array1Size++;
			}
		}
	
	if($EndFlag==1)	#           1 
		{
		$tmp=$_;
		$tmp=substr($tmp,0,1);
		if($tmp eq ";")			#     ,      2
			{
			$EndFlag=2;	 		#      
			}
		else
			{
			$String=$_;
			print("String= $String");
			system("pause");
			push(@Strings1, $String);
			$Array1Size++;
			}
		}
}
close(FILE1);		#  

print("\nFILE 2.GCODE DONE \n");
print("Array2Size= $Array2Size\n");
system("pause");


open (RESULTFILE, ">$RESULTHANDLE") || die "\n FILE NOT EXIST \n \n";	#   ,    
#      2-    
while($Array1Size > 0)
	{
	#print("\n1!!!\n");
	$String = @Strings1[0];
	$tmp = shift(@Strings1);			#       @Strings1,  
	$Array1Size--;
	syswrite(RESULTFILE, $String, length($String));		#       
	#print($String);
	#system("pause");
	}
close(RESULTFILE);

print("\nFILE RESULTFILE.GCODE DONE \n");
system("pause");